=== test_package/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.2)

project(expresscpp-app
        CXX)

set(CMAKE_CXX_STANDARD 17)

include(${CMAKE_BINARY_DIR}/conanbuildinfo.cmake)
conan_basic_setup(TARGETS)

find_package(expresscpp
             REQUIRED)

add_executable(expresscpp-app example.cpp)
target_link_libraries(expresscpp-app
                      expresscpp::expresscpp)
